#! /bin/sh -e

if [ ! -d $1 ]; then
  echo "error: cannot find: $1"
  exit 1
fi

cd $1 

files=$(grep -rl $2 bin/aclocal* bin/auto* share/a*)

old=$(echo "$2" | sed -e 's/\//\\\//g' -e 's/\./\\\./g')
new=$(echo "$1" | sed -e 's/\//\\\//g' -e 's/\./\\\./g')

for f in $files
do
  mode=$(stat -f "%Op" $f)
  cat $f | sed -e "s/${old}/${new}/g" > $f.tmp
  chmod ${mode} $f.tmp
  rm -f $f
  mv $f.tmp $f
done
